<?php

	
	# MonoCMS plugin: RSS burn
	# author: pano z
	# version 1.1
	# plugin type: general
	



	if (getcwd() == 'plugins')
		exit;
	
	if ((isset($btn) && $btn == 'postbutton') || (isset($_GET['editfile']) && isset($draft_file)) || (isset($_GET['file']) && isset($del))) {
		
		
		
		# Filename
		$filename = 'rss';

		# Rss title
		$title = 'Rss feed';

		# Rss description
		$rssdes = 'My content';

		# Number of latest posts to include in your feed.
		$number = 10;

		# Your Monocms installation directory
		# Examples: http://example.com or http://example.com/blog
		$address = '';

		# Amount of characters included in description. Leave empty to include all.
		$cut = ''; 


		$xmlfiles = glob('../monofiles/autosaves/*.xml');
		$xml = new SimpleXMLElement('<?xml version="1.0" encoding="utf-8"?><rss version="2.0"><channel><title>'.$title.'</title><link>'.$address.'</link><description></description></channel></rss>');


		# Find posts
		if (count($xmlfiles) > 0) {

			$array_xml = array();
			$array_ptime = array();

			foreach ($xmlfiles as $file) {

					$xmlElement = simplexml_load_file($file);

					if ($xmlElement->postinfo->post->type != 'Draft' && strpos($file,'nu') === false) {
						$array_xml[] = $file;
						$array_ptime[] = (int)$xmlElement->postinfo->post->ptime;
					}
			}

			$index_posts = array_combine($array_ptime,$array_xml);
			krsort($index_posts);

			$c=0;

			foreach($index_posts as $file) {

					if ($c == $number)
						break;

					$xmlpost = simplexml_load_file($file);	
					$headline = $xmlpost->postinfo->post->title;
					$path = $xmlpost->postinfo->post->path;
					$link = $xmlpost->postinfo->post->filename;

					$htm_file = '../monofiles/autosaves/content/'.basename($file,'.xml').'.htm';

					file_exists($htm_file) ? $content = strip_tags(str_replace('&','&amp;',file_get_contents($htm_file))) : $content = ' ';

					$pubdate = date('r',(int)$xmlpost->postinfo->post->ptime);

					#add item
					$item = $xml->channel->addChild('item','');
					$item->addChild('title',str_replace('&','&amp;',$headline));
					$item->addChild('link',$address.'/'.$path.$link.'.php');

					if (is_int($cut)){

						$strip = htmlspecialchars($content,ENT_COMPAT);

						if (strlen($strip) > $cut) {
							$offset = ($cut - 3) - strlen($strip);
							$content = substr($strip, 0, strrpos($strip, ' ', $offset)).'&#8230;';
						}

					}

					$item->addChild('description',$content);
					$item->addChild('pubDate',$pubdate);



					unset($content);		

						$c++;



				}
				$xml->asXML('../'.$filename.'.xml');
		}
	}
		
	
?>